mod Ex08 logic: 'cl'

incl Mtex

incl Maux

loc rem 
  8. CVICENIE Z PREDMETU SPECIFIKACIA A VERIFIKACIA PROGRAMOV

rem 
  VASE MENO: ?
  SKUPINA: ?
  VERZIA CL: 5.81.16
  DATUM: stvrtok 7.4.2005
  ******************************************************************************
  SKUSKA (toto je len zakladny ramec, viz. tiez 1. prednaska):
   A = aspon 90 bodov
   B = aspon 80 bodov
   C = aspon 70 bodov
   D = aspon 60 bodov
   E = aspon 50 bodov
  ******************************************************************************
  PMAIL: svp@nw.fmph.uniba.sk
  WWW: http://www.ii.fmph.uniba.sk/cl/view.php/courses/svp
  konzultacie: stvrtok 13:00-14:00 miestnost I25

rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane binarnym stromom. 
  Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subor \it  mtex.cl  \end obsahuje makra pre CL-TeX. 
   \item \para Subor(y) \it  maux*.cl  \end obsahuju definicie a vlastnosti 
         pomocnych funkcii a predikatov. 
   \item \para Subor(y) \it  ex08*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

fun/0 Foo 'Tex_f0_foo'
  Foo = 0

pred/0 Poo 'Tex_p0_poo'
  Poo <-> \f

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Trees.  \end 

rem 
  \para \bf  Section. Binary Trees.  \end 

rem 
  \para \bf  Arithmetization of labeled binary trees.  \end 

fun/0 E 'Tex_f0_bt_e'
  E = 0,0

fun/3 Nd 'Tex_f3_bt_nd'
  Nd(x,l,r) = 1,x,l,r

pred Bt 
  Bt(E)
  Bt Nd(x,l,r) <- N(x) & Bt(l) & Bt(r)

rem 
  \para \bf  Justification of case analysis on binary trees.  \end Prove 
  \eq* 
    Bt(t) -> t = E \/ \e x\e l\e r(t = Nd(x,l,r) & N(x))
  \end
  \para \it  Hint.  \end Use pair case analysis on \ft t \end. 

thm Case_analysis_on_binary_trees
  Bt(t) -> t = E \/ \e x\e l\e r(t = Nd(x,l,r) & N(x))

rem 
  \para \bf  [CL] Case analysis on binary trees.  \end Syntax: 
  \items 
   \item \para The command \it  case  \end \ft Bt \end \it  ;  \end 
         \ft Tex0_tau \end invokes case analysis on the binary tree 
         \ft Tex0_tau \end. 
  \end
  \para See also the theorem \ft Case_analysis_on_binary_trees \end. 

rem 
  \para \bf  Justification of structural induction on binary trees.  \end 
  Demonstrate the admissibility of structural induction on binary_trees. 

theory Admissibility_of_structural_induction_on_binary_trees

pred A 'Tex_p1_phi_subst'

axiom Base_case
  A(E)

axiom Induction_step
  A(l) & A(r) -> A Nd(x,l,r)

loc rem 
  \para \it  [CL] Hint.  \end Prove the following claim by induction with 
  measure \ft |t| \end. 

thm Conclusion
  Bt(t) -> A(t)

end theory Admissibility_of_structural_induction_on_binary_trees

rem 
  \para \bf  Exercise.  \end Demonstrate the admissibility of structural 
  induction on binary_trees (strong form). 

theory Admissibility_of_structural_induction_on_binary_trees_strong_form

pred A 'Tex_p1_phi_subst'

axiom Base_case
  A(E)

axiom Induction_step
  Bt(l) & A(l) & Bt(r) & A(r) -> A Nd(x,l,r)

loc rem 
  \para \it  [CL] Hint.  \end Prove the following claim by induction with 
  measure \ft |t| \end. 

thm Conclusion
  Bt(t) -> A(t)

end theory Admissibility_of_structural_induction_on_binary_trees_strong_form

rem 
  \para \bf  [CL] Structural induction on binary trees.  \end Syntax: 
  \items 
   \item \para The command \it  ind  \end \ft Bt \end \it  ;  \end \ft t \end 
         invokes structural induction on the binary tree \ft t \end with the 
         induction formula \ft Tex2_bappl1(Tex0_phi,t) \end, where 
         \ft Tex2_bappl1(Tex0_phi,t) \end is the current goal possibly with 
         additional free variables as parameters. 
   \item \para The command \it  ind  \end \ft Bt \end \it  ;  \end \ft t \end 
         \it  ;  \end \ft Tex1_hat(y) \end invokes structural induction on the 
         binary tree \ft t \end with the induction formula 
         \ft Tex2_forall(Tex1_hat(y),Tex3_bappl2(Tex0_phi,t,Tex1_hat(y))) \end, 
         where \ft Tex3_bappl2(Tex0_phi,t,Tex1_hat(y)) \end is the current goal 
         possibly with additional free variables as parameters. 
   \item \para The command \it  ind*  \end \ft Bt \end \it  ;  \end \ft t \end 
         invokes structural induction on the binary tree \ft t \end (strong 
         form) with the induction formula \ft Tex2_bappl1(Tex0_phi,t) \end, 
         where \ft Tex2_bappl1(Tex0_phi,t) \end is the current goal possibly 
         with additional free variables as parameters. 
   \item \para The command \it  ind*  \end \ft Bt \end \it  ;  \end \ft t \end 
         \it  ;  \end \ft Tex1_hat(y) \end invokes structural induction on the 
         binary tree \ft t \end (strong form) with the induction formula 
         \ft Tex2_forall(Tex1_hat(y),Tex3_bappl2(Tex0_phi,t,Tex1_hat(y))) \end, 
         where \ft Tex3_bappl2(Tex0_phi,t,Tex1_hat(y)) \end is the current goal 
         possibly with additional free variables as parameters. 
  \end

rem 
  \para \bf  Membership in binary trees.  \end 

pred/2 Inbt 'Tex_p2_bt_in'
  Inbt(x,t) <-> Poo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Inbt_e
    ~Inbt(x,E)
  \end
  \eq Inbt_nd
    Inbt(x,Nd(y,l,r)) <-> x = y \/ Inbt(x,l) \/ Inbt(x,r)
  \end

thm Inbt_e
  ~Inbt(x,E)

thm Inbt_nd
  Inbt(x,Nd(y,l,r)) <-> x = y \/ Inbt(x,l) \/ Inbt(x,r)

rem 
  \para \bf  Size and depth of binary trees.  \end 

fun Sz 'Tex_f1_bt_sz'
  Sz(t) = Foo

fun Dp 'Tex_f1_bt_dp'
  Dp(t) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Sz_e
    Bt(t) -> Sz(t) = 0 <-> t = E
  \end
  \eq Dp_e
    Bt(t) -> Dp(t) = 0 <-> t = E
  \end
  \eq Dp_sz
    Bt(t) -> Dp(t) <= Sz(t) & Sz(t) < Exp(2,Dp(t))
  \end
  \para \it  [CL] Hint.  \end Use the theorem \it  Exp_le  \end in the proof 1 
  rem of \it  Dp_sz  \end. 

thm Sz_e
  Bt(t) -> Sz(t) = 0 <-> t = E

thm Dp_zero
  Bt(t) -> Dp(t) = 0 <-> t = E

thm Dp_sz
  Bt(t) -> Dp(t) <= Sz(t) & Sz(t) < Exp(2,Dp(t))
proof  proved.

rem 
  \para \bf  Reflection function.  \end 

fun Reflect 
  Reflect(t) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Reflect_bt
    Bt(t) -> Bt Reflect(t)
  \end
  \eq Reflect_inbt
    Bt(t) -> Inbt(x,Reflect(t)) <-> Inbt(x,t)
  \end
  \eq Reflect_sz
    Bt(t) -> Sz Reflect(t) = Sz(t)
  \end
  \eq Reflect_dp
    Bt(t) -> Dp Reflect(t) = Dp(t)
  \end
  \eq Reflect_reflect
    Bt(t) -> Reflect Reflect(t) = t
  \end
  \eq Reflect_injective
    Bt(t1) & Bt(t2) & Reflect(t1) = Reflect(t2) -> t1 = t2
  \end
  \eq Reflect_surjective
    Bt(t1) -> \e t2 Reflect(t2) = t1
  \end

thm Reflect_bt
  Bt(t) -> Bt Reflect(t)

thm Reflect_inbt
  Bt(t) -> Inbt(x,Reflect(t)) <-> Inbt(x,t)

thm Reflect_sz
  Bt(t) -> Sz Reflect(t) = Sz(t)
proof  proved.

thm Reflect_dp
  Bt(t) -> Dp Reflect(t) = Dp(t)
proof  proved.

thm Reflect_reflect
  Bt(t) -> Reflect Reflect(t) = t

thm Reflect_injective
  Bt(t1) & Bt(t2) & Reflect(t1) = Reflect(t2) -> t1 = t2

thm Reflect_surjective
  Bt(t1) -> \e t2 Reflect(t2) = t1

rem 
  \para \bf  Traversals of binary trees.  \end 

fun Preorder 
  Preorder(t) = Foo

fun Inorder 
  Inorder(t) = Foo

fun Postorder 
  Postorder(t) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Preorder_m
    Bt(t) -> L Preorder(t) = Sz(t)
  \end
  \eq Preorder_inbt
    Bt(t) -> x in Preorder(t) <-> Inbt(x,t)
  \end
  \eq Inorder_m
    Bt(t) -> L Inorder(t) = Sz(t)
  \end
  \eq Inorder_inbt
    Bt(t) -> x in Inorder(t) <-> Inbt(x,t)
  \end
  \eq Postorder_m
    Bt(t) -> L Postorder(t) = Sz(t)
  \end
  \eq Postorder_inbt
    Bt(t) -> x in Postorder(t) <-> Inbt(x,t)
  \end

thm Preorder_m
  Bt(t) -> L Preorder(t) = Sz(t)
proof  proved.

thm Preorder_inbt
  Bt(t) -> x in Preorder(t) <-> Inbt(x,t)

thm Inorder_m
  Bt(t) -> L Inorder(t) = Sz(t)
proof  proved.

thm Inorder_inbt
  Bt(t) -> x in Inorder(t) <-> Inbt(x,t)

thm Postorder_m
  Bt(t) -> L Postorder(t) = Sz(t)
proof  proved.

thm Postorder_inbt
  Bt(t) -> x in Postorder(t) <-> Inbt(x,t)

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Preorder_postorder
    Bt(t) -> Preorder(t) = Rev Postorder Reflect(t)
  \end
  \eq Postorder_preorder
    Bt(t) -> Postorder(t) = Rev Preorder Reflect(t)
  \end

thm Preorder_postorder
  Bt(t) -> Preorder(t) = Rev Postorder Reflect(t)
proof  proved.

thm Postorder_preorder
  Bt(t) -> Postorder(t) = Rev Preorder Reflect(t)
proof  proved.

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Inorder_inorder
    Bt(t) -> Inorder(t) = Rev Inorder Reflect(t)
  \end

thm Inorder_inorder
  Bt(t) -> Inorder(t) = Rev Inorder Reflect(t)
proof  proved.

rem 
  \para \bf  Fast programs for tree traversals.  \end 

rem 
  \para \bf  Case: preorder traversal.  \end 

fun/2 Preordera 'Tex_f2_f'
  Preordera(t,a) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Preorder_by_preordera
    Bt(t) -> Preorder(t) = Preordera(t,0)
  \end

thm Preorder_by_preordera
  Bt(t) -> Preorder(t) = Preordera(t,0)
proof  proved.

rem 
  \para \bf  Case: inorder traversal.  \end 

rem 
  \para \bf  Exercise.  \end Save the concatenation in the definition of the 
  function \ft Inorder(t) \end with help of an accumulator function and verify 
  your implementation. 

rem 
  \para \bf  Case: postorder traversal.  \end 

rem 
  \para \bf  Exercise.  \end Save the concatenation in the definition of the 
  function \ft Postorder(t) \end with help of an accumulator function and verify 
  your implementation. 

rem 
  \para \bf  Tail recursive tree traversals.  \end 

rem 
  \para \bf  Case: preorder traversal.  \end 

fun/2 Preorderb 'Tex_f2_f'
  Preorderb(s,a) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Preorder_by_preorderb
    Bt(t) -> Preorder(t) = Preorderb((t,0),0)
  \end

thm Preorder_by_preorderb
  Bt(t) -> Preorder(t) = Preorderb((t,0),0)
proof  proved.

rem 
  \para \bf  Case: inorder traversal.  \end 

rem 
  \para \bf  Exercise.  \end Find a tail recursive derivation of the function 
  \ft Inorder(t) \end and verify your implementation. 

rem 
  \para \bf  Case: postorder traversal.  \end 

rem 
  \para \bf  Exercise.  \end Find a tail recursive derivation of the function 
  \ft Postorder(t) \end and verify your implementation. 

rem 
  \para \bf  Subtrees.  \end 

pred/2 Subtree 'Tex_p2_bt_subtree'
  Subtree(t1,t2) <-> Poo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Subtree_e_right
    Subtree(t,E) <-> t = E
  \end
  \eq Subtree_nd_right
    Subtree(t,Nd(x,l,r)) <-> t = Nd(x,l,r) \/ Subtree(t,l) \/ Subtree(t,r)
  \end

thm Subtree_e_right
  Subtree(t,E) <-> t = E

thm Subtree_nd_right
  Subtree(t,Nd(x,l,r)) <-> t = Nd(x,l,r) \/ Subtree(t,l) \/ Subtree(t,r)

rem 
  \para \bf  Exercise.  \end Define a function \ft Subtrees(t) \end satisfying 
  \eq Spec_subtrees
    Bt(t) -> t1 in Subtrees(t) <-> Subtree(t1,t)
  \end
  \para Prove that the function has the required property. 

fun Subtrees 
  Subtrees(E) = E,0
  Subtrees Nd(x,l,r) = Nd(x,l,r),Subtrees(l)++Subtrees(r)

thm Spec_subtrees
  Bt(t) -> t1 in Subtrees(t) <-> Subtree(t1,t)

rem 
  \para \bf  Isomorphic binary trees.  \end 

pred/2 Isomorphic 'Tex_p2_bt_isomorphic'
  Isomorphic(t1,t2) <-> Poo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq Isomorphic_refl
    Bt(t) -> Isomorphic(t,t)
  \end
  \eq Isomorphic_sym
    Bt(t1) & Bt(t2) & Isomorphic(t1,t2) -> Isomorphic(t2,t1)
  \end
  \eq Isomorphic_trans
    Bt(t1) & Bt(t2) & Bt(t3) & Isomorphic(t1,t2) & Isomorphic(t2,t3) -> 
    Isomorphic(t1,t3)
  \end
  \eq Isomorphic_sz
    Bt(t1) & Bt(t2) & Isomorphic(t1,t2) -> Sz(t1) = Sz(t2)
  \end
  \eq Isomorphic_dp
    Bt(t1) & Bt(t2) & Isomorphic(t1,t2) -> Dp(t1) = Dp(t2)
  \end
  \eq Isomorphic_reflect
    Bt(t1) & Bt(t2) -> Isomorphic(Reflect(t1),Reflect(t2)) <-> Isomorphic(t1,t2)
  \end

thm Isomorphic_refl
  Bt(t) -> Isomorphic(t,t)

thm Isomorphic_sym
  Bt(t1) & Bt(t2) & Isomorphic(t1,t2) -> Isomorphic(t2,t1)

thm Isomorphic_trans
  Bt(t1) & Bt(t2) & Bt(t3) & Isomorphic(t1,t2) & Isomorphic(t2,t3) -> 
  Isomorphic(t1,t3)

thm Isomorphic_sz
  Bt(t1) & Bt(t2) & Isomorphic(t1,t2) -> Sz(t1) = Sz(t2)
proof  proved.

thm Isomorphic_dp
  Bt(t1) & Bt(t2) & Isomorphic(t1,t2) -> Dp(t1) = Dp(t2)
proof  proved.

thm Isomorphic_reflect
  Bt(t1) & Bt(t2) -> Isomorphic(Reflect(t1),Reflect(t2)) <-> Isomorphic(t1,t2)

